function TNE_Emote_OnLoad()

TNE_Emote_Version = "3.1"

-- set default values. these will be overriden when variables are loaded
TNE_Emote_Default_Enabled = true
TNE_Emote_Default_NotificationDuration = 00
TNE_Emote_Default_FlashOnce = true

TNE_Emote_Default_FadeInTime = 0.3
TNE_Emote_Default_FadeOutTime = 0.7
TNE_Emote_Default_FadeInDelay = 0
TNE_Emote_Default_FadeOutDelay = 0

TNE_Emote_Default_Color = { 256, 256, 256 } -- r,g,b


TNE_Emote_Enabled = TNE_Emote_Default_Enabled
TNE_Emote_NotificationDuration = TNE_Emote_Default_NotificationDuration
TNE_Emote_FlashOnce = TNE_Emote_Default_FlashOnce

TNE_Emote_FadeInTime = TNE_Emote_Default_FadeInTime
TNE_Emote_FadeOutTime = TNE_Emote_Default_FadeOutTime
TNE_Emote_FadeInDelay = TNE_Emote_Default_FadeInDelay
TNE_Emote_FadeOutDelay = TNE_Emote_Default_FadeOutDelay

TNE_Emote_Color = TNE_Emote_Default_Color

-- command line
SlashCmdList["EmoteCMD"] = TNE_Emote_CMD
SLASH_EmoteCMD1 = "/emote"

this:SetAlpha(0)
this:Show()
this:RegisterEvent("VARIABLES_LOADED")

end

function TNE_Emote_ApplySettings()

local frame = getglobal("EmoteFrame")

UIFrameFlashRemoveFrame(frame)
UIFrameFadeRemoveFrame(frame)
UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)

-- register or unregister when turning modes on or off
if (TNE_Emote_Enabled) then
  frame:RegisterEvent("CHAT_MSG_EMOTE")
  frame:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
  TNE_Emote_LastSentEmote = 0
  EmoteFrameTexture:SetVertexColor(unpack(TNE_Emote_Color))
else
  frame:UnregisterEvent("CHAT_MSG_EMOTE")
  frame:UnregisterEvent("CHAT_MSG_TEXT_EMOTE")
end

end


function TNE_Emote_OnEvent(event)

local now, frame = GetTime(), EmoteFrame

if (frame.locked) then
  return
end

if (event == "CHAT_MSG_EMOTE") then
  if not (TNE_Emote_LastSentEmote > now - TNE_Emote_NotificationDuration) then
    UIFrameFlash(frame, TNE_Emote_FadeInTime, TNE_Emote_FadeOutTime, TNE_Emote_FlashOnce and 2 or -1, nil, TNE_Emote_FadeOutDelay, TNE_Emote_FadeInDelay)
  end
elseif (event == "CHAT_MSG_TEXT_EMOTE") then
  TNE_Emote_LastSentEmote = now
  UIFrameFlashRemoveFrame(frame)
  UIFrameFadeRemoveFrame(frame)
  UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)
end

end

function TNE_Emote_CMD(arg1)

if (not arg1) then
  return
end

ShowUIPanel(EmoteSettingsFrame)

end