function TNE_Says_OnLoad()

TNE_Says_Version = "3.1"

-- set default values. these will be overriden when variables are loaded
TNE_Says_Default_Enabled = true
TNE_Says_Default_NotificationDuration = 0
TNE_Says_Default_FlashOnce = true

TNE_Says_Default_FadeInTime = 0.3
TNE_Says_Default_FadeOutTime = 0.7
TNE_Says_Default_FadeInDelay = 0
TNE_Says_Default_FadeOutDelay = 0

TNE_Says_Default_Color = { 256, 256, 256 } -- r,g,b

TNE_Says_Enabled = TNE_Says_Default_Enabled
TNE_Says_NotificationDuration = TNE_Says_Default_NotificationDuration
TNE_Says_FlashOnce = TNE_Says_Default_FlashOnce

TNE_Says_FadeInTime = TNE_Says_Default_FadeInTime
TNE_Says_FadeOutTime = TNE_Says_Default_FadeOutTime
TNE_Says_FadeInDelay = TNE_Says_Default_FadeInDelay
TNE_Says_FadeOutDelay = TNE_Says_Default_FadeOutDelay

TNE_Says_Color = TNE_Says_Default_Color

-- command line
SlashCmdList["SaysCMD"] = TNE_Says_CMD
SLASH_SaysCMD1 = "/says"

this:SetAlpha(0)
this:Show()
this:RegisterEvent("VARIABLES_LOADED")

end

function TNE_Says_ApplySettings()

local frame = getglobal("SaysFrame")

UIFrameFlashRemoveFrame(frame)
UIFrameFadeRemoveFrame(frame)
UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)

-- register or unregister when turning modes on or off
if (TNE_Says_Enabled) then
  frame:RegisterEvent("CHAT_MSG_SAY")
  frame:RegisterEvent("CHAT_MSG_SAY_INFORM")
  TNE_Says_LastSentSay = 0
  SaysFrameTexture:SetVertexColor(unpack(TNE_Says_Color))
else
  frame:UnregisterEvent("CHAT_MSG_SAY")
  frame:UnregisterEvent("CHAT_MSG_SAY_INFORM")
end

end

function TNE_Says_OnEvent(event)

local now, frame = GetTime(), SaysFrame

if (frame.locked) then
  return
end

if (event == "CHAT_MSG_SAY") then
  if not (TNE_Says_LastSentSay > now - TNE_Says_NotificationDuration) then
    UIFrameFlash(frame, TNE_Says_FadeInTime, TNE_Says_FadeOutTime, TNE_Says_FlashOnce and 2 or -1, nil, TNE_Says_FadeOutDelay, TNE_Says_FadeInDelay)
  end
elseif (event == "CHAT_MSG_SAY_INFORM") then
  TNE_Says_LastSentSay = now
  UIFrameFlashRemoveFrame(frame)
  UIFrameFadeRemoveFrame(frame)
  UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)
end

end

function TNE_Says_CMD(arg1)

if (not arg1) then
  return
end

ShowUIPanel(SaysSettingsFrame)

end