function TNE_Yells_OnLoad()

TNE_Yells_Version = "3.1"

-- set default values. these will be overriden when variables are loaded
TNE_Yells_Default_Enabled = true
TNE_Yells_Default_NotificationDuration = 0
TNE_Yells_Default_FlashOnce = true

TNE_Yells_Default_FadeInTime = 0.3
TNE_Yells_Default_FadeOutTime = 0.7
TNE_Yells_Default_FadeInDelay = 0
TNE_Yells_Default_FadeOutDelay = 0

TNE_Yells_Default_Color = { 256, 256, 256 } -- r,g,b

TNE_Yells_Enabled = TNE_Yells_Default_Enabled
TNE_Yells_NotificationDuration = TNE_Yells_Default_NotificationDuration
TNE_Yells_FlashOnce = TNE_Yells_Default_FlashOnce

TNE_Yells_FadeInTime = TNE_Yells_Default_FadeInTime
TNE_Yells_FadeOutTime = TNE_Yells_Default_FadeOutTime
TNE_Yells_FadeInDelay = TNE_Yells_Default_FadeInDelay
TNE_Yells_FadeOutDelay = TNE_Yells_Default_FadeOutDelay

TNE_Yells_Color = TNE_Yells_Default_Color

-- command line
SlashCmdList["YellsCMD"] = TNE_Yells_CMD
SLASH_YellsCMD1 = "/yells"

this:SetAlpha(0)
this:Show()
this:RegisterEvent("VARIABLES_LOADED")

end

function TNE_Yells_ApplySettings()

local frame = getglobal("YellsFrame")

UIFrameFlashRemoveFrame(frame)
UIFrameFadeRemoveFrame(frame)
UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)

-- register or unregister when turning modes on or off
if (TNE_Yells_Enabled) then
  frame:RegisterEvent("CHAT_MSG_YELL")
  frame:RegisterEvent("CHAT_MSG_YELL_INFORM")
  TNE_Yells_LastSentYell = 0
  YellsFrameTexture:SetVertexColor(unpack(TNE_Yells_Color))
else
  frame:UnregisterEvent("CHAT_MSG_YELL")
  frame:UnregisterEvent("CHAT_MSG_YELL_INFORM")
end

end

function TNE_Yells_OnEvent(event)

local now, frame = GetTime(), YellsFrame

if (frame.locked) then
  return
end

if (event == "CHAT_MSG_YELL") then
  if not (TNE_Yells_LastSentYell > now - TNE_Yells_NotificationDuration) then
    UIFrameFlash(frame, TNE_Yells_FadeInTime, TNE_Yells_FadeOutTime, TNE_Yells_FlashOnce and 2 or -1, nil, TNE_Yells_FadeOutDelay, TNE_Yells_FadeInDelay)
  end
elseif (event == "CHAT_MSG_YELL_INFORM") then
  TNE_Yells_LastSentYell = now
  UIFrameFlashRemoveFrame(frame)
  UIFrameFadeRemoveFrame(frame)
  UIFrameFadeOut(frame, 1, frame:GetAlpha(), 0)
end

end

function TNE_Yells_CMD(arg1)

if (not arg1) then
  return
end

ShowUIPanel(YellsSettingsFrame)

end